﻿
SPEC_PORTRAITS_LIST = {	
	"Interface\\ICONS\\Ability_Druid_OwlkinFrenzy.blp",
	"Interface\\ICONS\\INV_Staff_99.blp",
	"Interface\\ICONS\\ABILITY_DRUID_DEMORALIZINGROAR.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}

SPEC_PORTRAITS_LIST_UNFORM = {
	"Interface\\ICONS\\INV_MISC_PETMOONKINNE.blp",
	"Interface\\ICONS\\Achievement_Halloween_Cat_01.blp",
	"Interface\\ICONS\\inv_misc_bearcubbrown.blp",
	"Interface\\ICONS\\Ability_Druid_NaturalPerfection.blp"
}


SPEC_BUFF_LIST = {16886,127538,62606,100977}




---- AlertFrame -------------------------------------------------------------------------------
AlertFrame = CreateFrame("Frame"); 
AlertFrame:ClearAllPoints(); 
AlertFrame:SetHeight(100); 
AlertFrame:SetWidth(100); 
AlertFrame:SetPoint("CENTER", UIParent, "CENTER");
AlertFrame:SetScript("OnUpdate", function(self, elapsed)
	if (AlertFrame.Time < GetTime() - 3) then		
		local alpha = AlertFrame:GetAlpha()
		if (alpha ~= 0) then AlertFrame:SetAlpha(alpha - .05) end
		if (aplha == 0) then AlertFrame:Hide() end
	end
end
) 
AlertFrame:Hide(); 
AlertFrame.text = AlertFrame:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont"); 
AlertFrame.text:SetAllPoints(); 
AlertFrame.Time = 0;
  
function AlertMsg(message, color) 
	AlertFrame.text:SetText(message); 
	if color=="green" then
		AlertFrame.text:SetTextColor(0,1,0)
	elseif color == "red" then
		AlertFrame.text:SetTextColor(1,0,0)
	else 
		AlertFrame.text:SetTextColor(1,1,1)
	end
	AlertFrame:SetAlpha(1); 
	AlertFrame:Show(); 
	AlertFrame.Time = GetTime(); 
end
----------------------------------------------------------------------------------------------



function RageBar_OnLoad(self)	
	self:SetMinMaxValues(0,100)
	self:SetValue(100)
	self:SetStatusBarColor(0.8,0,0)
end

function RageBar_OnUpdate(self, elapsed)
	if GetShapeshiftFormID() == 5 then
		local currentChance = self:GetValue()
		local newChance = UnitPower("player", SPELL_POWER_RAGE)	
		if newChance - currentChance > 1 then
			self:SetValue(currentChance + 1)
		elseif newChance - currentChance <= 1  and newChance - currentChance > 0 then
			self:SetValue(newChance)
		elseif currentChance - newChance > 10 then
			self:SetValue(currentChance - 10)
		elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
			self:SetValue(newChance)
		end 
		self.text:SetText(self:GetValue())
		local _, maxValue = self:GetMinMaxValues()
		self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
	else 
		self:SetValue(10)
		self.spark:SetPoint("LEFT", self, "LEFT", 17.6 - 15, -3)
	end
	
	
end

function EnergyBar_OnLoad(self) 	
	self:SetMinMaxValues(0,100)
	self:SetValue(100)
	self:SetStatusBarColor(1, 1, 0)
end

function EnergyBar_OnUpdate(self, elasped)
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_ENERGY)	
	if newChance - currentChance > 1 then
		self:SetValue(currentChance + 1)
	elseif newChance - currentChance <= 1  and newChance - currentChance > 0 then
		self:SetValue(newChance)
	elseif currentChance - newChance > 10 then
		self:SetValue(currentChance - 10)
	elseif currentChance - newChance > 0 and currentChance - newChance < 10 then
		self:SetValue(newChance)
	end 
	self.text:SetText(self:GetValue())
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", self:GetValue()/maxValue*176 - 15, -1)
end

function ManaBar_OnLoad(self) 	
	
	self:SetMinMaxValues(0, UnitPowerMax("player"))
	self:SetValue(UnitPower("player")) 
	self:SetStatusBarColor(0.0, 0.15 ,0.70)
end

function ManaBar_OnUpdate(self, elasped)
	--self:SetMinMaxValues(0, UnitPower("player", SPELL_POWER_MANA)) 
	local currentChance = self:GetValue()
	local newChance = UnitPower("player", SPELL_POWER_MANA)		
	self:SetValue(newChance)	
	local _, maxValue = self:GetMinMaxValues()
	self.spark:SetPoint("LEFT", self, "LEFT", newChance/maxValue*176 - 15, -3)
	self.text:SetText(newChance)
end


function EclipseBar_OnLoad(self)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")	
end

function EclipseBar_OnUpdate(self, elapsed)
	MasterSS_SolarMask:SetFrameLevel(100)
	MasterSS_LunarMask:SetFrameLevel(100)
	
	local newChance = UnitPower("player", SPELL_POWER_ECLIPSE)	
	local direction = GetEclipseDirection()	
	
	if newChance >= 0 then
		MasterSS_SolarMask:SetValue(newChance)
		MasterSS_LunarMask:SetValue(0)
	elseif newChance < 0 then
		MasterSS_LunarMask:SetValue(newChance)
		MasterSS_SolarMask:SetValue(0)
	end
	
	MasterSS_LunarMask.spark:SetPoint("LEFT", MasterSS_LunarMask, "LEFT", (100 + MasterSS_LunarMask:GetValue())/100*88 - 15, -3)
	MasterSS_SolarMask.spark:SetPoint("LEFT", MasterSS_SolarMask, "LEFT", MasterSS_SolarMask:GetValue()/100*88 - 15, -3)
	
	
	if (newChance > 0 and direction == "moon") or self.nextToEclipse == 1 then -- Sun Eclipse
		SolarIconActive:Show()
		SolarIcon:Hide()
		SolarIconActive.pulse:Play()
	else 
		SolarIconActive:Hide()
	end
	
	if (newChance < 0 and direction == "sun") or self.nextToEclipse == -1 then -- Moon Eclipse
		LunarIconActive:Show()
		LunarIcon:Hide()
		LunarIconActive.pulse:Play()
	else 
		LunarIconActive:Hide()
	end
	
	if newChance < 0 then
		newChance = -newChance
	end
	if direction == "moon" then
		MasterSS_EclipseBar_Text:SetText("<"..newChance)
	else 
		MasterSS_EclipseBar_Text:SetText(newChance..">")
	end	
end

function EclipseBar_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	
	if sourceName == UnitName("player") then
	
			if eventType == "SPELL_CAST_START" then
				local spellId, spellName, spellSchool = select(12, ...)
				local auraType = select(15, ...)
				--MasterSS:showMsg(spellId .."-".. spellName)
				local power = UnitPower("player", SPELL_POWER_ECLIPSE)
				
				if spellId == 2912  then -- starfire
					if power >= 60 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)
						SolarIconActive:Show()
						self.nextToEclipse = 1
						AlertMsg("即将进蚀", "green")
					end
					
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 5176 then --wrath
					if power <= -70 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)
						LunarIconActive:Show()
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end
					
					if power <= 35 and power > 15 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end												
				end
				
				if spellId == 78674 then -- starsurge
					if power >= 60 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)						
						self.nextToEclipse = 1
						AlertMsg("即将进蚀","green")
					end
					if power <= -60 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(0,1,0)						
						
						self.nextToEclipse = -1
						AlertMsg("即将进蚀","green")
					end	
					if power >= -40 and power < -20 and GetEclipseDirection() == "sun" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀","red")
					end
					if power <= 35 and power > 20 and GetEclipseDirection() == "moon" then
						MasterSS_EclipseBar_Text:SetTextColor(1,0,0)
						AlertMsg("即将出蚀", "red")
					end	
				end--starsurge				
			end--cast start
			
			if eventType == "SPELL_ENERGIZE" or eventType == "SPELL_CAST_FAILED" then
				MasterSS_EclipseBar_Text:SetTextColor(1,1,1)
				if self.nextToEclipse == -1 then
					self.nextToEclipse = 0
					LunarIconActive:Hide()
				elseif self.nextToEclipse == 1 then
					self.nextToEclipse = 0
					SolarIconActive:Hide()
				end
			end
	end	
end

function SetCombo(id, combo, active, inCD)
	if active then
		if id == 1 or id == 4 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else
				combo:SetTexture("Interface/COMMON/Indicator-Green.blp")
			end
		elseif id == 2 then
			combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
		elseif id == 3 then
			if inCD then
				combo:SetTexture("Interface/COMMON/Indicator-Yellow.blp")
			else 	
				combo:SetTexture("Interface/COMMON/Indicator-Red.blp")
			end
		end
	else 
		combo:SetTexture("Interface/COMMON/Indicator-Gray.blp")
	end
end

function ComboBar_OnUpdate(self, elapsed)
	local spec = GetSpecialization()
	MasterSS_ComboTimer:Hide()
	if  spec == 2 then --cat
		local pts = GetComboPoints("player","target")
		if pts == 0 then
			SetCombo(spec, MasterSS_Combo1, false)
			SetCombo(spec, MasterSS_Combo2, false)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)			
		elseif pts == 1 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, false)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 2 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, false)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 3 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, false)
			SetCombo(spec, MasterSS_Combo5, false)		
		elseif pts == 4 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, true)
			SetCombo(spec, MasterSS_Combo5, false)
		elseif pts == 5 then
			SetCombo(spec, MasterSS_Combo1, true)
			SetCombo(spec, MasterSS_Combo2, true)
			SetCombo(spec, MasterSS_Combo3, true)
			SetCombo(spec, MasterSS_Combo4, true)
			SetCombo(spec, MasterSS_Combo5, true)
		end
	elseif spec == 3 then -- Bear
		local pts, maxCharges, timeLastCast, cooldownDuration  = GetSpellCharges(62606)
		local left = cooldownDuration - GetTime() + timeLastCast
		MasterSS_ComboTimer:SetText(string.format("%d", left))
		MasterSS_ComboTimer:Show()
		local _, _, _, powerCost = GetSpellInfo(62606) 
		local low = UnitPower("player", SPELL_POWER_RAGE) < powerCost
		if pts == 0 then		
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo3, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, false, low)
			SetCombo(spec, MasterSS_Combo4, false, low)
			SetCombo(spec, MasterSS_Combo5, false, low)			
		elseif pts == 1 then			
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo4, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, false, low)
			SetCombo(spec, MasterSS_Combo5, false, low)		
		elseif pts == 2 then			
			MasterSS_ComboTimer:SetPoint("CENTER", MasterSS_Combo5, "CENTER",1,2)
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, true, low)
			SetCombo(spec, MasterSS_Combo5, false, low)		
		elseif pts == 3 then			
			MasterSS_ComboTimer:Hide()
			SetCombo(spec, MasterSS_Combo3, true, low)
			SetCombo(spec, MasterSS_Combo4, true, low)
			SetCombo(spec, MasterSS_Combo5, true, low)	
		end	
	elseif spec == 1 or spec == 4 then -- moonkin mushroom
		local pts = 0
		local i
		for i = 1,3 do
			local haveTotem, _, _, _, _ = GetTotemInfo(i)
			if haveTotem then 
				pts = pts + 1
			end
		end
		local start1, _,_ = GetSpellCooldown(88751)
		local start2, _,_ = GetSpellCooldown(102791)
		local inCD = start1 ~= 0 or start2 ~= 0
		if pts == 0 then			
			SetCombo(spec, MasterSS_Combo3, false, inCD)
			SetCombo(spec, MasterSS_Combo4, false, inCD)
			SetCombo(spec, MasterSS_Combo5, false)			
		elseif pts == 1 then			
			SetCombo(spec, MasterSS_Combo3, true, inCD)
			SetCombo(spec, MasterSS_Combo4, false, inCD)
			SetCombo(spec, MasterSS_Combo5, false, inCD)		
		elseif pts == 2 then			
			SetCombo(spec, MasterSS_Combo3, true, inCD)
			SetCombo(spec, MasterSS_Combo4, true, inCD)
			SetCombo(spec, MasterSS_Combo5, false, inCD)		
		elseif pts == 3 then			
			SetCombo(spec, MasterSS_Combo3, true,inCD)
			SetCombo(spec, MasterSS_Combo4, true,inCD)
			SetCombo(spec, MasterSS_Combo5, true,inCD)	
		end
	end
end



function ResetComboBar()
	local spec = GetSpecialization()
	if spec == 2 then
		MasterSS_ComboBorder1:Show()
		MasterSS_ComboBorder2:Show()
		MasterSS_Combo1:Show()
		MasterSS_Combo2:Show()
	else 
		MasterSS_ComboBorder1:Hide()
		MasterSS_ComboBorder2:Hide()
		MasterSS_Combo1:Hide()
		MasterSS_Combo2:Hide()
	end
	
end 

function BuffBar_OnUpdate(self, elapsed)
	self.total = self.total + elapsed
	
	if self.total >= .1 then		
		self.total = 0
		if MasterSS_BuffStatusBar:GetValue() > 0 then
			MasterSS_BuffStatusBar:SetValue(MasterSS_BuffStatusBar:GetValue() - 0.1)
			BuffBar_Text:SetText(string.format("%.1f", MasterSS_BuffStatusBar:GetValue()))
		else
			BuffBar_Text:SetText("")
		end
		if GetSpecialization() == 3 then
			BuffBar_Text2:SetText(string.format("%.1f",GetDodgeChance()).."%")
		end
	end	
end



function BuffBar_OnEvent(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	if sourceName == UnitName("player") then
		--print(eventType)
		if eventType == "SPELL_CAST_SUCCESS" or eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" then
			local spellId, spellName, spellSchool = select(12, ...)
			local auraType = select(15, ...)
			--print(eventType.."-"..spellId.."-"..spellName)
			if spellId == SPEC_BUFF_LIST[GetSpecialization()] then
				local name, rank, icon, count, dispelType, duration, expires = UnitBuff("player", spellName)
				MasterSS_BuffStatusBar:SetValue(duration)		
				MasterSS_BuffPortrait:SetTexture(icon)
			end			
		end
	end
end


local function SetDebuff(slot, text, id)
	if id ~= nil then
		local n = GetSpellInfo(id)
		local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitDebuff("target", n)
		if name ~= nil then
			slot:SetAlpha(1.0)
			slot:SetTexture(icon)
			local leftTime = format("%d", expires - GetTime())
			if expires - GetTime() >= 3 then
				text:SetTextColor(0,1,0)
			else 
				text:SetTextColor(1,0,0)
			end
			text:SetText(leftTime)
			text:Show()
		else 
			slot:SetAlpha(0.5)
			text:Hide()
		end		
	end
end

local function SetBuff(slot, text, id, glow)	
	if id ~= nil and slot:IsShown() then
		local n = GetSpellInfo(id)
		local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitBuff("player", n)
		if name ~= nil then --active
			slot:SetAlpha(1.0)
			slot:SetTexture(icon)
			local leftTime = format("%d", expires - GetTime())			
			text:SetTextColor(0,1,0)			
			text:SetText(leftTime)
			text:Show()
		else 
			local start, duration, enable = GetSpellCooldown(id)			
			if start ~= 0 and duration > 1.5 then --In CD
				slot:SetAlpha(0.5)
				text:SetTextColor(1,0,0)
				local leftTime = duration - GetTime() + start
				local t
				text:SetFontObject("PVPInfoTextFont")
				if leftTime >= 60 then
					text:SetFontObject("NumberFont_Shadow_Small")
					t = format("%d", leftTime/60) .. ":" .. format("%02d", leftTime%60)
				elseif leftTime >= 1 then
					t = format("%d", leftTime)
				elseif leftTime >0 then
					t = format("%.1f", leftTime)	
				end
				text:Show()
				text:SetText(t)
				if glow ~= nil and glow.playing == 1 then
					glow:Hide()
					glow.animIn:Stop()
					glow.playing = 0
				end
			else -- CD ready
				slot:SetAlpha(1)
				text:Hide()
				if glow ~= nil and glow.playing == 0 then
					glow:Show()
					glow.animIn:Play()
					glow.playing = 1
				end
			end			
		end		
	end
end


-- First ability will be the most right one because debuff frame is anchored to right
local DEBUFF_LIST = {
	{8921,93402, nil, nil}, --Moonkin
	{1079, 1822, 113746, 106830}, --Cat
	{113746, 33745, 77758,nil}, --Bear
	{nil, nil, nil, nil}
}

--Cast-when-ready
local BUFF1_LIST = {
	{78674, 48505}, --Moonkin
	{5217, nil}, --Cat
	{33878, nil}, --Bear
	{18562, 48438} -- resto
}

--Long-cd
local BUFF2_LIST = {
	{112071, 102560}, --Moonkin
	{106952, 102543}, --Cat
	{106952, 102558}, --Bear
	{740, 117679} --resto
}

function UpdateIcon(spec)
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then
		
		MasterSS_BuffFrame1.slot1:SetTexture(select(3, GetSpellInfo(BUFF1_LIST[spec][1])))
		if BUFF1_LIST[spec][2] ~= nil then
			MasterSS_BuffFrame1.slot2:SetTexture(select(3, GetSpellInfo(BUFF1_LIST[spec][2])))
			MasterSS_BuffFrame1.slot2:Show()
			MasterSS_BuffFrame1.text2:Show()
			MasterSS_BuffFrame1.glow2:Show()
		else 
			MasterSS_BuffFrame1.slot2:Hide()
			MasterSS_BuffFrame1.text2:Show()
			MasterSS_BuffFrame1.glow2:Hide()
		end
		
		MasterSS_BuffFrame2.slot1:SetTexture(select(3, GetSpellInfo(BUFF2_LIST[spec][1])))
		local isFree, index = GetTalentRowSelectionInfo(4)
		if index == 11 then -- incarnation
			MasterSS_BuffFrame2.slot2:SetTexture(select(3, GetSpellInfo(BUFF2_LIST[spec][2])))
			MasterSS_BuffFrame2.slot2:Show()
		else
			MasterSS_BuffFrame2.slot2:Hide()
			MasterSS_BuffFrame2.text2:Hide()
		end
		
		MasterSS_DebuffFrame.slot1:SetTexture(select(3, GetSpellInfo(DEBUFF_LIST[spec][1])))
		MasterSS_DebuffFrame.slot2:SetTexture(select(3, GetSpellInfo(DEBUFF_LIST[spec][2])))
		MasterSS_DebuffFrame.slot3:SetTexture(select(3, GetSpellInfo(DEBUFF_LIST[spec][3])))
		MasterSS_DebuffFrame.slot4:SetTexture(select(3, GetSpellInfo(DEBUFF_LIST[spec][4])))
	end
end

function DebuffFrame_OnUpdate(self, elapsed)
	local spec = GetSpecialization()
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then
		SetDebuff(self.slot1, self.text1, DEBUFF_LIST[spec][1])
		SetDebuff(self.slot2, self.text2, DEBUFF_LIST[spec][2])
		SetDebuff(self.slot3, self.text3, DEBUFF_LIST[spec][3])
		SetDebuff(self.slot4, self.text4, DEBUFF_LIST[spec][4])
	end
end



function BuffFrame1_OnUpdate(self,elapsed) 
	local spec = GetSpecialization()
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then		
		SetBuff(self.slot1, self.text1, BUFF1_LIST[spec][1], self.glow1)
		SetBuff(self.slot2, self.text2, BUFF1_LIST[spec][2], self.glow2)
	end
end

function BuffFrame2_OnUpdate(self,elapsed) 
	local spec = GetSpecialization()
	if spec == 1 or spec == 2 or spec == 3 or spec == 4 then		
		SetBuff(self.slot1, self.text1, BUFF2_LIST[spec][1])
		SetBuff(self.slot2, self.text2, BUFF2_LIST[spec][2])
	end
end


function UpdatePortrait() 
	if UnitIsDeadOrGhost("player") == 1 then
		MasterSS_Portrait:SetTexture("Interface\\ICONS\\INV_MISC_FOOD_15.blp")
	elseif GetSpecialization() == nil then
		MasterSS_Portrait:SetTexture("Interface\\ICONS\\Ability_Druid_MasterShapeshifter.blp")
	else
		if GetShapeshiftFormID() == nil then
			MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
		else			
			if (GetSpecialization() == 1 and GetShapeshiftFormID() == 31) or (GetSpecialization() == 2 and GetShapeshiftFormID() == 1) or (GetSpecialization() == 3 and GetShapeshiftFormID() == 5) then
				MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST[GetSpecialization()])
			else
				MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[GetSpecialization()])
			end
		end
	end
end 

function applySpecialization()
	SPEC_ID = GetSpecialization()	
	
	MasterSS.RageBar:Hide()
	MasterSS.EnergyBar:Hide()
	MasterSS.ManaBar:Hide()
	MasterSS.EclipseBar:Hide()
	
	ResetComboBar()
	MasterSS_ComboFrame:Show()

	UpdateIcon(SPEC_ID)	
	
	MasterSS_Portrait:SetTexture(SPEC_PORTRAITS_LIST_UNFORM[SPEC_ID])
	ManaBar_OnLoad(MasterSS.ManaBar)
	
	if SPEC_ID == 1 then --Monnkin
		MasterSS.EclipseBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,18)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.13,0.93,0)
		
	elseif SPEC_ID == 2 then --Cat
		MasterSS.EnergyBar:Show()	
		MasterSS_BuffStatusBar:SetMinMaxValues(0,45)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.75,0,0)
		
	elseif SPEC_ID == 3 then --Bear
		MasterSS.RageBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,18)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.73,0.73,0)
	elseif SPEC_ID == 4 then --Tree
		MasterSS.ManaBar:Show()
		MasterSS_BuffStatusBar:SetMinMaxValues(0,20)
		MasterSS_BuffStatusBar:SetValue(0)
	    MasterSS_BuffStatusBar:SetStatusBarColor(0.93,0.93,0)
	end	
end

-- binding
BINDING_HEADER_MYDOSTUFF = "Master Shape Shifter";
for i=1,6 do
	_G["BINDING_NAME_CLICK MSS_TalentButton"..i..":LeftButton"] = "Talent "..i
end






